/* Function: infofile
**
** Author: Paul W. Carlson	April 1992
*/

#include "map_info.h"
#include "ps_info.h"

#define KEY(x) (strcmp(key,x)==0)

static char *help[] =
{
    "where      x y",
    "font       fontname",
    "fontsize   fontsize",
    "color      color",
    "showregion yes/no",
    "scaletext  text", 
    ""
};

infofile()
{	
    char buf[1024];
    char *key, *data;
    int color, fontsize;
    double x, y;

    m_info.showregion = 0;
    m_info.scalename = "SCALE: ";
    fontsize = 0;
    color = BLACK;
    x = y = 0.0;
    while (input(2, buf, help))
    {
	if (!key_data(buf, &key, &data)) continue;

        if (KEY("where"))
 	{
	    scan_where(data, &x, &y);
            continue;
	}

	if (KEY("fontsize"))
	{
	    fontsize = atoi(data);
	    if (fontsize < 4 || fontsize > 50) fontsize = 0;
	    continue;
	}

	if (KEY("color"))
	{
	    color = get_color_number(data);
	    if (color < 0)
	    {
		color = BLACK;
		error(key, data, "illegal color request");
	    }
	    continue;
	}

        if (KEY("showregion"))
          {
          if (*data == 'n')
            m_info.showregion = 0;
          continue;
          };

 	if (KEY("scaletext"))
	  {
	    m_info.scalename = G_store(data);
	    continue;
	  };  

	if (KEY("font"))
	{
	    get_font(data);
	    m_info.font = G_store(data);
	    continue;
	}
	error(key, data, "illegal mapinfo sub-request");
    }
    m_info.x = x;
    m_info.y = y;
    m_info.color = color;
    if (fontsize) m_info.fontsize = fontsize;
}
