

#include "gis.h"
#include "pattern.h"

#define DELTA_Y	0.05
#define MAX_PSFILES	20


struct PS_data 
{
    /* The current region */
    struct Cell_head w;

    struct Colors colors;
    struct Categories cats;
    CELL min_color, max_color;
    char *cell_mapset;
    char *cell_name; 
    char *plfile;
    char *commentfile;
    char *grid_font;
    char *psfiles[MAX_PSFILES];
    char scaletext[100];
    char celltitle[100];
    PATTERN *pattable[256];
    int level;
    int grey;
    int mask_needed;
    int do_header;
    int do_raster;
    int do_colortable;
    int do_sitetable;
    int do_barscale;
    int num_psfiles;
    int grid, grid_color, grid_numbers, grid_numbers_color, grid_fontsize;
    double grid_width;
    int do_outline, outline_color;
    int cell_fd;

    /* how many rows/cols of raster map give one postscript row/column */
    int row_delta, col_delta; 

    /* Number of postscript dots in output map (depends on printer resolution) */
    int dots_wide, dots_high;

    int num_panels, startpanel, endpanel;


    /* These values are read from the current printer specification and are in inch */
    /* They specify paper dimensions and printer resolution */
    double page_width, page_height;
    double left_marg, right_marg, top_marg, bot_marg;
    int res;

    /* The printable area is computed from the values above (in inch) */
    double print_width, print_height;

    /* The position and area of the map is computed from the paper dimensions (in inch) */
    /* User may change this area with the "maploc" command */
    double map_width, map_height;
    double map_x_orig, map_y_orig;

    /* Lowest used y-value (in points) */
    double min_y;

    /* Current y-value (in points) */
    double cur_y;

    /* Width/height of printable area in points */
    double map_pix_wide, map_pix_high;

    /* Corners of printable area in points */
    double map_top, map_bot, map_left, map_right;

    /* scaling factors from GIS coordinates to postscript points */
    double ew_to_x, ns_to_y;

    double r0, g0, b0;
    double outline_width;
    FILE *fp;
};

#ifdef WHITE
#undef WHITE
#endif
#ifdef BLACK
#undef BLACK
#endif
#ifdef GREY
#undef GREY
#endif
#ifdef MAIN
struct PS_data PS;
int WHITE = 0;
int BLACK = 1;
int GREY = 9;
int sec_draw;
#else
extern struct PS_data PS;
extern int WHITE, BLACK, GREY, sec_draw;
#endif

double scale(char *text);



