#include "ps_info.h"


/*
 * Sets f to a value between PS.w.west and PS.w.east
 *
*/
scan_easting(char *buf, double *f)
{
    if (scan_percent(buf, f, PS.w.west, PS.w.east)) return 1;
    return G_scan_easting(buf, f, PS.w.proj);
}


/*
 * Sets f to a value between PS.w.south and PS.w.north
 *
*/

scan_northing(char *buf, double *f)
{
    if (scan_percent(buf, f, PS.w.south, PS.w.north)) return 1;
    return G_scan_northing(buf, f, PS.w.proj);
}


scan_resolution(char *buf, double *f)
{
    return G_scan_resolution(buf, f, PS.w.proj);
}


/*
 * If the buffer buf contains a valid percentage-description,
 * the variable f is set to the corresponding value between min and max
 * If successful, 1 is returned, else 0
*/
scan_percent(char *buf, double *f, double min, double max)
{
    char percent[3];

    *percent = 0;
    if (sscanf(buf, "%lf%2s", f, percent) != 2) return 0;
    if (strcmp(percent, "%") != 0) return 0;
    *f = min + (max-min) * (*f/100.0);
    return 1;
}

