/* Function: stablfile
**
** Author: Horst Raap	July 2000
** modeled after ctablfile
*/

#include "sitetable.h"
#include "ps_info.h"

#define KEY(x) (strcmp(key,x)==0)

static char *help[] =
{
    "where      x y",
    "width      table_width",
    "cols       columns",
    "font       fontname",
    "fontsize   fontsize",
    "color      color",
    ""
};

stablfile()
{	
    char buf[1024];
    char *key, *data;
    int color, fontsize, cols;
    double w, x, y;

    /* Set some defaults */
    fontsize = 10;
    color = BLACK;
    cols = 1;
    w = x = y = 0.0;
    while (input(2, buf, help))
    {
	if (!key_data(buf, &key, &data)) continue;

        if (KEY("where"))
 	{
	    scan_where(data, &x, &y);
	    continue;
	}

        if (KEY("width"))
 	{
	    if (sscanf(data, "%lf", &w) != 1)
	    {
		w = 0.0;
		error(key, data, "illegal width request");
	    }
	    else continue;
	}

        if (KEY("cols"))
 	{
	    if (sscanf(data, "%d", &cols) != 1)
	    {
		cols= 1;
		error(key, data, "illegal columns request");
	    }
	    else continue;
	}

	if (KEY("fontsize"))
	{
	    fontsize = atoi(data);
	    if (fontsize < 4 || fontsize > 50) fontsize = 0;
	    continue;
	}

	if (KEY("color"))
	{
	    color = get_color_number(data);
	    if (color < 0)
	    {
		color = BLACK;
		error(key, data, "illegal color request");
	    }
	    continue;
	}

	if (KEY("font"))
	{
	    get_font(data);
	    st.font = G_store(data);
	    continue;
	}
	error(key, data, "illegal sitetable sub-request");
    }
    st.x = x;
    st.y = y;
    st.width = w;
    st.color = color;
    st.cols = cols;
    if (fontsize) st.fontsize = fontsize;
}

